Module javafx.base
Package javafx.beans.property

## Class ListPropertyBase<E>

- java.lang.Object
- - javafx.beans.binding.ListExpression<E>
  - - javafx.beans.property.ReadOnlyListProperty<E>
    - - javafx.beans.property.ListProperty<E>
      - - javafx.beans.property.ListPropertyBase<E>

- Type Parameters:
    `E` - the type of the `List` elements
  All Implemented Interfaces:
    `Iterable<E>`, `Collection<E>`, `List<E>`, `Observable`, `Property<ObservableList<E>>`, `ReadOnlyProperty<ObservableList<E>>`, `ObservableListValue<E>`, `ObservableObjectValue<ObservableList<E>>`, `ObservableValue<ObservableList<E>>`, `WritableListValue<E>`, `WritableObjectValue<ObservableList<E>>`, `WritableValue<ObservableList<E>>`, `ObservableList<E>`
  Direct Known Subclasses:
    `SimpleListProperty`

      public abstract class ListPropertyBase<E>
      extends ListProperty<E>

  The class `ListPropertyBase` is the base class for a property wrapping an `ObservableList`. It provides all the functionality required for a property except for the `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()` methods, which must be implemented by extending classes.
  Since:
    JavaFX 2.1
  See Also:
    `ObservableList`, `ListProperty`

- - ### Property Summary

    Properties
    Type | Property | Description
    --- | --- | ---
    `ReadOnlyBooleanProperty` | `empty` | A boolean property that is `true`, if the list is empty.
    `ReadOnlyIntegerProperty` | `size` | An integer property that represents the size of the list.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ListPropertyBase()` | The Constructor of `ListPropertyBase`
    `ListPropertyBase​(ObservableList<E> initialValue)` | The constructor of the `ListPropertyBase`.

  - ### Method Summary

    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addListener​(InvalidationListener listener)` | Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
    `void` | `addListener​(ChangeListener<? super ObservableList<E>> listener)` | Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
    `void` | `addListener​(ListChangeListener<? super E> listener)` | Add a listener to this observable list.
    `void` | `bind​(ObservableValue<? extends ObservableList<E>> newObservable)` | Create a unidirection binding for this `Property`.
    `ReadOnlyBooleanProperty` | `emptyProperty()` | A boolean property that is `true`, if the list is empty.
    `protected void` | `fireValueChangedEvent()` | Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `ListChangeListener`.
    `protected void` | `fireValueChangedEvent​(ListChangeListener.Change<? extends E> change)` | Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `ListChangeListener`.
    `ObservableList<E>` | `get()` | Get the wrapped value.
    `protected void` | `invalidated()` | The method `invalidated()` can be overridden to receive invalidation notifications.
    `boolean` | `isBound()` | Can be used to check, if a `Property` is bound.
    `void` | `removeListener​(InvalidationListener listener)` | Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
    `void` | `removeListener​(ChangeListener<? super ObservableList<E>> listener)` | Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
    `void` | `removeListener​(ListChangeListener<? super E> listener)` | Tries to remove a listener from this observable list.
    `void` | `set​(ObservableList<E> newValue)` | Set the wrapped value.
    `ReadOnlyIntegerProperty` | `sizeProperty()` | An integer property that represents the size of the list.
    `String` | `toString()` | Returns a string representation of this `ListPropertyBase` object.
    `void` | `unbind()` | Remove the unidirectional binding for this `Property`.

    - ### Methods inherited from class javafx.beans.property.ListProperty

      `bindBidirectional, setValue, unbindBidirectional`

    - ### Methods inherited from class javafx.beans.property.ReadOnlyListProperty

      `bindContent, bindContentBidirectional, equals, hashCode, unbindContent, unbindContentBidirectional`

    - ### Methods inherited from class javafx.beans.binding.ListExpression

      `add, add, addAll, addAll, addAll, asString, clear, contains, containsAll, get, getSize, getValue, indexOf, isEmpty, isEqualTo, isNotEqualTo, isNotNull, isNull, iterator, lastIndexOf, listExpression, listIterator, listIterator, remove, remove, remove, removeAll, removeAll, retainAll, retainAll, set, setAll, setAll, size, subList, toArray, toArray, valueAt, valueAt`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, removeIf, stream, toArray`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface java.util.List

      `add, add, addAll, addAll, clear, contains, containsAll, equals, get, hashCode, indexOf, isEmpty, iterator, lastIndexOf, listIterator, listIterator, remove, remove, removeAll, replaceAll, retainAll, set, size, sort, spliterator, subList, toArray, toArray`

    - ### Methods inherited from interface javafx.collections.ObservableList

      `addAll, filtered, remove, removeAll, retainAll, setAll, setAll, sorted, sorted`

    - ### Methods inherited from interface javafx.beans.value.ObservableValue

      `getValue`

    - ### Methods inherited from interface javafx.beans.property.ReadOnlyProperty

      `getBean, getName`

    - ### Methods inherited from interface javafx.beans.value.WritableValue

      `getValue`

- - ### Property Detail

    - #### size

          public ReadOnlyIntegerProperty sizeProperty

      Specified by:
        `sizeProperty` in class `ListExpression<E>`
      See Also:
        `ListExpression.getSize()`

    - #### empty

          public ReadOnlyBooleanProperty emptyProperty

      Specified by:
        `emptyProperty` in class `ListExpression<E>`
      See Also:
        `ListExpression.isEmpty()`

  - ### Constructor Detail

    - #### ListPropertyBase

          public ListPropertyBase()

      The Constructor of `ListPropertyBase`

    - #### ListPropertyBase

          public ListPropertyBase​(ObservableList<E> initialValue)

      The constructor of the `ListPropertyBase`.
      Parameters:
        `initialValue` - the initial value of the wrapped value

  - ### Method Detail

    - #### sizeProperty

          public ReadOnlyIntegerProperty sizeProperty()

      Description copied from class: `ListExpression`
      An integer property that represents the size of the list.
      Specified by:
        `sizeProperty` in class `ListExpression<E>`
      See Also:
        `ListExpression.getSize()`

    - #### emptyProperty

          public ReadOnlyBooleanProperty emptyProperty()

      Description copied from class: `ListExpression`
      A boolean property that is `true`, if the list is empty.
      Specified by:
        `emptyProperty` in class `ListExpression<E>`
      See Also:
        `ListExpression.isEmpty()`

    - #### addListener

          public void addListener​(InvalidationListener listener)

      Description copied from interface: `Observable`
      Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

      The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

      Parameters:
        `listener` - The listener to register
      See Also:
        `Observable.removeListener(InvalidationListener)`

    - #### removeListener

          public void removeListener​(InvalidationListener listener)

      Description copied from interface: `Observable`
      Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Parameters:
        `listener` - The listener to remove
      See Also:
        `Observable.addListener(InvalidationListener)`

    - #### addListener

          public void addListener​(ChangeListener<? super ObservableList<E>> listener)

      Description copied from interface: `ObservableValue`
      Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

      The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

      Parameters:
        `listener` - The listener to register
      See Also:
        `ObservableValue.removeListener(ChangeListener)`

    - #### removeListener

          public void removeListener​(ChangeListener<? super ObservableList<E>> listener)

      Description copied from interface: `ObservableValue`
      Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Parameters:
        `listener` - The listener to remove
      See Also:
        `ObservableValue.addListener(ChangeListener)`

    - #### addListener

          public void addListener​(ListChangeListener<? super E> listener)

      Description copied from interface: `ObservableList`
      Add a listener to this observable list.
      Parameters:
        `listener` - the listener for listening to the list changes

    - #### removeListener

          public void removeListener​(ListChangeListener<? super E> listener)

      Description copied from interface: `ObservableList`
      Tries to remove a listener from this observable list. If the listener is not attached to this list, nothing happens.
      Parameters:
        `listener` - a listener to remove

    - #### fireValueChangedEvent

          protected void fireValueChangedEvent()

      Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `ListChangeListener`. This method is called when the value is changed, either manually by calling `set(ObservableList)` or in case of a bound property, if the binding becomes invalid.

    - #### fireValueChangedEvent

          protected void fireValueChangedEvent​(ListChangeListener.Change<? extends E> change)

      Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `ListChangeListener`. This method is called when the content of the list changes.
      Parameters:
        `change` - the change that needs to be propagated

    - #### invalidated

          protected void invalidated()

      The method `invalidated()` can be overridden to receive invalidation notifications. This is the preferred option in `Objects` defining the property, because it requires less memory. The default implementation is empty.

    - #### get

          public ObservableList<E> get()

      Description copied from interface: `WritableObjectValue`
      Get the wrapped value. This must be identical to the value returned from `WritableValue.getValue()`.

      This method exists only to align WritableObjectValue API with `WritableBooleanValue` and subclasses of `WritableNumberValue`

      Returns:
        The current value

    - #### set

          public void set​(ObservableList<E> newValue)

      Description copied from interface: `WritableObjectValue`
      Set the wrapped value. Should be equivalent to `WritableValue.setValue(java.lang.Object)`
      Parameters:
        `newValue` - The new value
      See Also:
        `WritableObjectValue.get()`

    - #### isBound

          public boolean isBound()

      Description copied from interface: `Property`
      Can be used to check, if a `Property` is bound.
      Returns:
        `true` if the `Property` is bound, `false` otherwise
      See Also:
        `Property.bind(javafx.beans.value.ObservableValue)`

    - #### bind

          public void bind​(ObservableValue<? extends ObservableList<E>> newObservable)

      Description copied from interface: `Property`
      Create a unidirection binding for this `Property`.

      Note that JavaFX has all the bind calls implemented through weak listeners. This means the bound property can be garbage collected and stopped from being updated.

      Parameters:
        `newObservable` - The observable this `Property` should be bound to.

    - #### unbind

          public void unbind()

      Description copied from interface: `Property`
      Remove the unidirectional binding for this `Property`. If the `Property` is not bound, calling this method has no effect.
      See Also:
        `Property.bind(javafx.beans.value.ObservableValue)`

    - #### toString

          public String toString()

      Returns a string representation of this `ListPropertyBase` object.
      Overrides:
        `toString` in class `ListProperty<E>`
      Returns:
        a string representation of this `ListPropertyBase` object.